<?php
/**
 * Created by PhpStorm.
 * User: Jonlin
 * Date: 2019/4/9
 * Time: 9:11
 */
namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request as Req;
use Illuminate\Support\Facades\DB;
Use App\Lib\Settlement\SettlementOrder;
use App\Models;
use Request;

/**
 *
 */
class SoccerNoteListController extends Controller
{

    public function notelist(Req $req)
    {
        $request['name_chinese'] = isset($req->name_chinese) ? trim($req->name_chinese) : null;
        $request['sureblurs'] = isset($req->sureblurs) ? $req->sureblurs : 'on';
        $request['account'] = isset($req->account) ? trim($req->account) :null ;
        $request['star_time'] = isset($req->star_time) ? trim($req->star_time) :null ;
        $request['end_time'] = isset($req->end_time) ? trim($req->end_time) :null ;
        $request['order_id'] = isset($req->order_id) ? trim($req->order_id) :null ;
        $request['match_id'] = isset($req->match_id) ? trim($req->match_id) :null ;
        $request['status'] = isset($req->status) ? trim($req->status) : '-1';
        $request['order_status'] = isset($req->order_status) ? trim($req->order_status) : '-1';
        $request['type'] = isset($req->type) ? trim($req->type) : 'zq';
        $dt = \App\Lib\DataTable\DataTable::init();
        $dt->setDataSource('/admin/SoccerNoteList/info');
        $dt->setLang('sportsnotelist');
        //$dt->addColsFields('id', array('templet' => '#userdetail', 'sort' => true, 'width' => 80));
        $dt->addColsFields('match_id_order', array('templet' => '#userdetail', 'sort' => true, 'width' => 200));
        $dt->addColsFields('league', array('templet' => '#userdetail', 'sort' => false, 'width' => 100));
        $dt->addColsFields('home_guest', array('templet' => '#userdetail', 'sort' => false, 'width' => 90));
        $dt->addColsFields('content', array('templet' => '#userdetail', 'sort' => false, 'width' => 250));
        $dt->addColsFields('money', array('templet' => '#userdetail', 'sort' => false, 'width' => 80));
        $dt->addColsFields('water_return', array('templet' => '#userdetail', 'sort' => false, 'width' => 70));
        $dt->addColsFields('prize_money', array('templet' => '#userdetail', 'sort' => false, 'width' => 80));
        $dt->addColsFields('result', array('templet' => '#userdetail', 'sort' => false, 'width' => 70));
        $dt->addColsFields('money_match_time', array('templet' => '#userdetail', 'sort' => false, 'width' => 200));
        $dt->addColsFields('order_status', array('sort' => false, 'width' => 90));
        $dt->addColsFields('account_money', array('templet' => '#userdetail', 'sort' => false, 'width' => 110));
        $dt->addColsFields('game_status', array('sort' => false, 'width' =>70));
        //$arr[] = 'view';
//        if (checkRriv('/admin/SoccerNoteList/edit')) {
//            $arr[] = 'edit';
//        }
//        $dt->setToolBar($arr, array('width' => 70));
        $dt->enableCheckBox();
        return view('sports/sports_notelist', $dt->render($request));
    }

    function info()
    {
        $page = Request::has('page') ? Request::get('page') : '';
        $list = Request::has('limit') ? Request::get('limit') : 10;
        $account = Request::get('account') ? Request::get('account') : '';
        $star_time = Request::get('star_time') ? Request::get('star_time').' 00:00:00' : '';
        $end_time = Request::get('end_time') ? Request::get('end_time').' 23:59:59' : '';
        $order_id = Request::get('order_id') ? Request::get('order_id') : '';
        $match_id = Request::get('match_id') ? Request::get('match_id') : '';
        $status = Request::has('status') ? Request::get('status') : '';
        $order_status = Request::has('order_status') ? Request::get('order_status') : '';
        $sureblur = Request::has('sureblurs') ? Request::get('sureblurs') : 'off';
        $type = Request::has('type') ? Request::get('type') : 'zq';
        $where = array();
        if (!empty($account)) {
            if (empty($sureblur) || $sureblur == 'off') {
                $where[] = array('money_buy_simplex.account_name', 'like', '%' . $account . '%');
            } else {
                $where[] = array('money_buy_simplex.account_name', '=', $account);
            }
        }
        if (!empty($star_time)) {
            if (!empty($end_time)){
                $where[] = array('money_buy_simplex.money_time', '>', $star_time);
                $where[] = array('money_buy_simplex.money_time', '<', $end_time);
            }else{
                $where[] = array('money_buy_simplex.money_time', '>', $star_time);
            }
        }else if(empty($star_time)){
            if (!empty($end_time)){

                $where[] = array('money_buy_simplex.money_time', '<', $end_time);
            }
        }
        if (!empty($order_id)){
            $where[] = array('money_buy_simplex.order_id', $order_id);
        }
        if (!empty($match_id)){
            $where[] = array('money_buy_simplex.match_id', $match_id);
        }
        if ($status != -1) {
            $where[] = array('money_buy_simplex.settle_status', '=', $status);
        }
        if ($order_status != -1) {
            $where[] = array('money_buy_simplex.status', '=', $order_status);
        }
        $where[] = array('money_buy_simplex.game_code', $type);
        $newapp = new \App\Models\SportsNoteList();
        $data = $newapp->getinfo($list, $page, $where,$type);

        return \App\Lib\DataTable\DataTable::init()->toJson($data['data'], $data['total'], 0, $where);
    }

    /**
     *单式注单作废
     */
    public function invalid(Req $req)
    {
        $id = $req->id;
        if (intval($id) < 1) {
            return -1;
        }
        $order = \App\Models\SportsNoteList::where('id',$id)->first();
        //用戶账户金额
        $account_money = \App\Models\Account_detailed::where('account_identity',$order->account_identity)->first();
        //反水
        $water_return_money = \App\Models\Money_details::where('trade_id',$order->order_id)->where('trade_type','7')->first();
        if(!empty($water_return_money)){
            $water_return = $water_return_money->money;
        }else{
            $water_return = 0;
        }
        //撤单后用户账户金额
        $available_cash = $account_money->available_cash;
        $new_available_cash = $available_cash+$order->money-$order->gain_money-$water_return;

        $model =new \App\Models\Money_details();
        $model->info_identity = UUID();
        $model->trade_id = $order->order_id;
        $model->account_name = $order->account_name;
        $model->account_identity = $order->account_identity;
        $model->money = abs($order->money-$order->gain_money-$water_return);
        $model->money_time = date("Y-m-d H:i:s",time());
        if($new_available_cash>$available_cash){
            $model->money_type = '1';
        }else{
            $model->money_type = '2';
        }
        $model->money_cash = $new_available_cash;
        $model->trade_type = '3';
        $model->trade_desc = '管理员作废单式注单';
        $model->status = '1';
        try {
            DB::beginTransaction();//开启事务
            \App\Models\SportsNoteList::where('id',$id)->update(['status'=>'2','gain_money'=>'0']);
            \App\Models\Account_detailed::where('account_identity',$order->account_identity)->update(['available_cash'=>$new_available_cash,'cash'=>$new_available_cash]);
            $model->save();

            DB::commit();//提交
            return 1;
        } catch (Exception $e) {
            DB::rollback();//回滚
            return -1;
        }
    }

    /**
     *单式注单首次结算
     */
    public function settlement(Req $req)
    {
        $id = $req->id;
        if (intval($id) < 1) {
            return -1;
        }
        $order = \App\Models\SportsNoteList::where('id', $id)->first();
        $order_ids = array($order->order_id);
        $match_id = $order->match_id;
        $game_code = $order->game_code;
        //return $match_id;
        //判断输赢
        $comendnotice = new \App\Models\Comendnotice();
        $res = $comendnotice->addcomendnotice($match_id);
        //结算
        $SettlementOrder = new SettlementOrder();
        $bet_type = 1;//单式注单
        $settype = 1; //首次结算
        $data = $SettlementOrder->reSettlement($order_ids,$bet_type,$settype,$game_code,$match_id);
        return $data;
    }


    /**
     *单式注单重新结算
     */
    public function resettlement(Req $req) {
        $id = $req->id;
        if (intval($id) < 1) {
            return -1;
        }
        $order = \App\Models\SportsNoteList::where('id',$id)->first();
        $match_id = $order->match_id;
        $game_code = $order->game_code;
        $order_ids = array($order->order_id);
        //return $match_id;
        //重新判断输赢
        $comendnotice = new \App\Models\Comendnotice();
        $res = $comendnotice->addcomendnotice($match_id);
        //结算
        $SettlementOrder = new SettlementOrder();
        $bet_type = 1;//单式注单
        $settype = 2; //重新结算
        $data = $SettlementOrder->reSettlement($order_ids,$bet_type,$settype,$game_code,$match_id);
        return $data;
    }

    /**
     *单式注单批量结算
     */
    public function batchsettlement(){
        $orders = \App\Models\SportsNoteList::where('settle_status','1')->get();
        $order_ids = array();
        for($i=0;$i<count($orders);$i++){
            $result = \App\Models\MoneyBuyMatch::where('batch_id',$orders[$i]->batch_id)->where('match_id',$orders[$i]->match_id)->get();
            $res = array();
            for($j=0;$j<count($result);$j++){
                $res[] = $result[$j]->result;
            }
            if(!in_array(0,$res)){
                $order_ids[] = $orders[$i]->order_id;
            }
        }
        $SettlementOrder = new SettlementOrder();
        $bet_type = 1;//单式注单
        $data = $SettlementOrder->reSettlement($order_ids,$bet_type);
        return $data;
    }

    /**
     *删除订单
     */
    public function delete(Req $req) {
        $id = $req->input('id');
        if (empty($id)) {
            return responseToJson(-2001); //id����Ϊ��
        }
        $ids = explode(',', $id);
        if (!is_array($ids) && intval($ids) < 0) {
            return responseToJson(-2002); //id����
        }
        if (is_array($ids) && count($ids) > 0) {
            foreach ($ids as $k => $v) {
                if (intval($v) < 1) {
                    unset($ids[$k]);
                }
            }
        }

        $rows = \App\Models\SportsNoteList::whereIn('id', $ids)->delete();
        if (!$rows) {
            return responseToJson(-2003); //id����
        }
        return responseToJson(1, trans('menu.delete_success')); //id����

    }

    /**
     * 投注金额统计
     */
    function moneycount()
    {
        $where = Request::has('where') ? Request::get('where') : '';
        $type = Request::has('type') ? Request::get('type') : 'zq';
        $db = new \App\Models\SportsNoteList;

        $data = $db->MoneyCount($where,$type);
        return responseToJson($data);
    }

}